window.onload = function() {
  showLoading();
  var iconLoad = new air.Loader();

  //windows system tray
  if(air.NativeApplication.supportsSystemTrayIcon) {
    iconLoad.contentLoaderInfo.addEventListener(air.Event.COMPLETE, function(event) {
      air.NativeApplication.nativeApplication.icon.bitmaps = new runtime.Array(event.target.content.bitmapData);
    });
    iconLoad.load(new air.URLRequest('icons/flair_16.png'));
    air.NativeApplication.nativeApplication.icon.tooltip = 'flair';
    
    air.SystemTrayIcon(air.NativeApplication.nativeApplication.icon).addEventListener(air.MouseEvent.CLICK, appIconClicked);
  }
  
  //osx dock
  if(air.NativeApplication.supportsDockIcon) {
    iconLoad.contentLoaderInfo.addEventListener(air.Event.COMPLETE, function(event) {
      air.NativeApplication.nativeApplication.icon.bitmaps = new runtime.Array(event.target.content.bitmapData);
    });
    iconLoad.load(new air.URLRequest('icons/flair_128.png'));
    
    air.NativeApplication.nativeApplication.addEventListener(air.InvokeEvent.INVOKE, appIconClicked);
  }  

  //setup menu items
  var root = new air.NativeMenu();
  air.NativeApplication.nativeApplication.icon.menu = root;
  
  var history = new air.NativeMenuItem('Notification History', false);
  history.addEventListener(air.Event.SELECT, displayHistory);
  root.addItem(history);
  
  var profile = new air.NativeMenuItem('My Facebook Profile', false);
  profile.addEventListener(air.Event.SELECT, facebookWindow);
  root.addItem(profile);
  
  var help = new air.NativeMenuItem('Help', false);
  help.addEventListener(air.Event.SELECT, helpWindow);
  root.addItem(help);
  
  var about = new air.NativeMenuItem('About flair', false);
  about.addEventListener(air.Event.SELECT, aboutWindow);
  root.addItem(about);
  
  //exit for windows
  if(air.NativeApplication.supportsSystemTrayIcon) {
    var exit = new air.NativeMenuItem('Exit', false);
    exit.addEventListener(air.Event.SELECT, exitApp);
    root.addItem(exit);
  }

  //reset vars  
  writeEncryptedStore('sessionKey', '');
  writeEncryptedStore('uid', '0');
  writeEncryptedStore('secret', '');

  //get token
  callFacebook({
    method: 'auth.createToken',
    onComplete: function(event) {
      var loader = air.URLLoader(event.target); 
      var dp = new DOMParser();
      var xml = dp.parseFromString(loader.data, 'text/xml');
      writeEncryptedStore('authToken', xml.documentElement.childNodes[0].nodeValue);
      
      //show help on first load
      var loadedOnce = readEncryptedStore('loadedOnce');
      if(!loadedOnce || loadedOnce == '') {
        writeEncryptedStore('loadedOnce', 'true');
        global.windows.loading.close();
        helpWindow(function() {
          showLogin();
        });
      }
      else {
        showLogin();
      }
    }
  });
};

//-------------------------

var displayNotificationsTimer = new air.Timer(30000, 0); //check the local db every 30 seconds
displayNotificationsTimer.addEventListener(air.TimerEvent.TIMER, displayNewNotifications);
//displayNotificationsTimer.start();

var storeNotificationsTimer = new air.Timer(60000, 0); //contact facebook every 60 seconds
storeNotificationsTimer.addEventListener(air.TimerEvent.TIMER, storeNewNotifications);
//storeNotificationsTimer.start();